# -*- coding: utf-8 -*-
#
# Copyright (C) 2014 Thomas Amland
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

_actions = [
  ["Navigation", [
    "left"              , "Nach links",
    "right"             , "Nach rechts",
    "up"                , "Nach oben",
    "down"              , "Nach unten",
    "pageup"            , "Seite nach oben",
    "pagedown"          , "Seite nach unten",
    "select"            , "Menüpunkt wählen",
    "highlight"         , "Menüpunkt hervorheben",
    #"parentdir"         , "NAV_BACK",       # backward compatibility
    #"close"             , "NAV_BACK", # backwards compatibility
    "parentfolder"      , "übergeordnetes Verzeichnis",
    "back"              , "Zurück",
    "previousmenu"      , "Vorheriges Menü",
    "info"              , "Info anzeigen",
    "contextmenu"       , "Kontextmenü",
    "firstpage"         , "Erste Seite",
    "lastpage"          , "Letzte Seite",
    "nextletter"        , "Nächster Buchstabe",
    "prevletter"        , "Vorheriger Buchstabe",
  ]],

  ["Wiedergabe", [
    "play"              , "Wiedergabe",
    "pause"             , "Pause",
    "playpause"         , "Wiedergabe/Pause",
    "stop"              , "Stop",
    "skipnext"          , "Vorwärtsspringen",
    "skipprevious"      , "Zurückspringen",
    "fastforward"       , "Schnell vorwärts",
    "rewind"            , "Zurückspulen",
    "smallstepback"     , "Kleiner Schritt zurück",
    "stepforward"       , "Schritt vorwärts",
    "stepback"          , "Schritt zurück",
    "bigstepforward"    , "Großer Schritt vorwärts",
    "bigstepback"       , "Großer Schritt zurück",
    "chapterorbigstepforward", "Nächstes Kapitel oder großer Schritt vorwärts",
    "chapterorbigstepBack"   , "Vorheriges Kapitel oder großer Schritt zurück",
    "osd"               , "OSD anzeigen",
    "showtime"          , "Aktuelle Wiedergabezeit anzeigen",
    "playlist"          , "Wiedergabeliste anzeigen",
    "fullscreen"        , "Vollbildschirm umschalten",
    "aspectratio"       , "Seitenverhältnis ändern",
    "showvideomenu"     , "Zum DVD-Videomenü gehen",
    "playercontrol(repeat)"   , "Wiederholung",
    "playercontrol(repeatone)", "1x wiederholen",
    "playercontrol(repeatall)", "Alles wiederholen",
    "playercontrol(repeatoff)", "Keine Wiederholung",
    "playercontrol(random)"   , "Zufallswiedergabe",
    "playercontrol(randomon)" , "Zufallswiedergabe einschalten",
    "playercontrol(randomoff)", "Zufallswiedergabe ausschalten",
    "createbookmark"          , "Lesezeichen erstellen",
    "createepisodebookmark"   , "Episode-Lesezeichen erstellen",
    "togglestereomode"        , "3D-Stereoskopischer Modus",
    "switchplayer"            , "Player wechseln",
  ]],

  ["Audio", [
    "mute"              , "Stumm",
    "volumeup"          , "Lautstärke hoch",
    "volumedown"        , "Lautstärke runter",
    "audionextlanguage" , "Nächste Sprache",
    "audiodelay"        , "Audioverzögerung",
    "audiodelayminus"   , "Audioverzögerung verringern",
    "audiodelayplus"    , "Audioverzögerung erhöhen",
    "audiotoggledigital", "Digital/Analogumschaltung",
  ]],

  ["Bilder", [
    "nextpicture"       , "Nächstes Bild",
    "previouspicture"   , "Vorheriges Bild",
    "rotate"            , "Bild drehen",
    "rotateccw"         , "CCW-Bild drehen",
    "zoomout"           , "Herauszoomen",
    "zoomin"            , "Hineinzoomen",
    "zoomnormal"        , "Zoomstufe: Normal",
    "zoomlevel1"        , "Zoomstufe: 1",
    "zoomlevel2"        , "Zoomstufe: 2",
    "zoomlevel3"        , "Zoomstufe: 3",
    "zoomlevel4"        , "Zoomstufe: 4",
    "zoomlevel5"        , "Zoomstufe: 5",
    "zoomlevel6"        , "Zoomstufe: 6",
    "zoomlevel7"        , "Zoomstufe: 7",
    "zoomlevel8"        , "Zoomstufe: 8",
    "zoomlevel9"        , "Zoomstufe: 9",
  ]],

  ["Untertitel", [
    "showsubtitles"     , "Untertitel anzeigen",
    "nextsubtitle"      , "Nächste Untertitel",
    "subtitledelay"     , "Untertitelverzögerung",
    "subtitledelayminus", "Verzögerung verringern",
    "subtitledelayplus" , "Verzögerung erhöhen",
    "subtitlealign"     , "Untertitelausrichtung",
    #"subtitleshiftup"   , "SUBTITLE_VSHIFT_UP", #?
    #"subtitleshiftdown" , "SUBTITLE_VSHIFT_DOWN", #?
  ]],

  ["PVR", [
    "channelup"             , "Kanal hoch",
    "channeldown"           , "Kanal runter",
    "previouschannelgroup"  , "Vorherige Kanalgruppe",
    "nextchannelgroup"      , "Nächste Kanalgruppe",
    "record"                , "Aufzeichnen",
  ]],

  ["Elementaktionen", [
    "queue"             , "Warteschlangenelement",
    "delete"            , "Element löschen",
    "copy"              , "Element kopieren",
    "move"              , "Objektverschiebung",
    "moveitemup"        , "Objekt nach oben verschieben",
    "moveitemdown"      , "Objekt nach unten verschieben",
    "rename"            , "Objekt umbenennen",
    "scanitem"          , "Objekt scannen",
    "togglewatched"     , "Beobachtungsstatus umschalten",
    #"increaserating"    , "INCREASE_RATING", #unused
    #"decreaserating"    , "DECREASE_RATING", #unused
  ]],

  ["System", [
    "togglefullscreen"  , "Vollbildschirm umschalten",
    "minimize"          , "Minimieren",
    "shutdown"          , "Herunterfahren",
    "reboot"            , "Neu starten",
    "hibernate"         , "Ruhezustand",
    "suspend"           , "Aussetzen",
    "restartapp"        , "MediaCenter neu starten",
    "system.logoff"     , "Abmelden",
    "quit"              , "MediaCenter beenden",
  ]],

  ["Virtuelle Tastatur", [
    "enter"             , "Enter-Taste",
    "shift"             , "Umschalt-Taste",
    "symbols"           , "Zeichen-Taste",
    "backspace"         , "Rückschritt-Taste",
    "number0"           , "0",
    "number1"           , "1",
    "number2"           , "2",
    "number3"           , "3",
    "number4"           , "4",
    "number5"           , "5",
    "number6"           , "6",
    "number7"           , "7",
    "number8"           , "8",
    "number9"           , "9",
    "red"               , "Teletext: Rot",
    "green"             , "Teletext: Grün",
    "yellow"            , "Teletext: Gelb",
    "blue"              , "Teletext: Blau",
  ]],

  ["Andere", [
    "updatelibrary(video)", "Video-Bibliothek aktualisieren",
    "updatelibrary(music)", "Musik-Bibliothek aktualisieren",
    "cleanlibrary(video)",  "Video-Bibliothek bereinigen",
    "cleanlibrary(music)", "Musik-Bibliothek bereinigen",
    "codecinfo"         , "Codec-Info anzeigen",
    "screenshot"        , "Einen Screenshot machen",
    "reloadkeymaps"     , "Tastenbelegungen neu laden",
    "increasepar"       , "PAR erhöhen",
    "decreasepar"       , "PAR verringern",
    "nextresolution"    , "Auflösung ändern",
    "nextcalibration"   , "Nächste Kalibrierung",
    "resetcalibration"  , "Kalibrierung zurücksetzen",
    "showpreset"        , "Aktuelle Visualisierungseinstellung anzeigen",
    "presetlist"        , "Visualisierungsvoreinstellungsliste anzeigen",
    "nextpreset"        , "Nächste Visualisierungsvoreinstellung",
    "previouspreset"    , "Vorherige Visualisierungsvoreinstellung",
    "lockpreset"        , "Aktuelle Visualisierungsvoreinstellung sperren",
    "randompreset"      , "Zur neuen zufälligen Voreinstellung wechseln",
  ]],

  #["Analog", [
  #  "scrollup"          , "SCROLL_UP",
  #  "scrolldown"        , "SCROLL_DOWN",
  #  "cursorleft"        , "CURSOR_LEFT",
  #  "cursorright"       , "CURSOR_RIGHT",
  #  "analogmove"        , "ANALOG_MOVE",
  #  "analogfastforward" , "ANALOG_FORWARD",
  #  "analogrewind"      , "ANALOG_REWIND",
  #  "analogseekforward" , "ANALOG_SEEK_FORWARD",
  #  "analogseekback"    , "ANALOG_SEEK_BACK",
  #  "leftclick"         , "MOUSE_LEFT_CLICK",
  #  "rightclick"        , "MOUSE_RIGHT_CLICK",
  #  "middleclick"       , "MOUSE_MIDDLE_CLICK",
  #  "doubleclick"       , "MOUSE_DOUBLE_CLICK",
  #  "wheelup"           , "MOUSE_WHEEL_UP",
  #  "wheeldown"         , "MOUSE_WHEEL_DOWN",
  #  "mousedrag"         , "MOUSE_DRAG",
  #  "mousemove"         , "MOUSE_MOVE",
  #]]

  #"verticalshiftup"   , "VSHIFT_UP",
  #"verticalshiftdown" , "VSHIFT_DOWN",
  #"increasevisrating" , "VIS_RATE_PRESET_PLUS",
  #"decreasevisrating" , "VIS_RATE_PRESET_MINUS",
  #"nextscene"         , "NEXT_SCENE",
  #"previousscene"     , "PREV_SCENE",
  #"jumpsms2"          , "JUMP_SMS2",
  #"jumpsms3"          , "JUMP_SMS3",
  #"jumpsms4"          , "JUMP_SMS4",
  #"jumpsms5"          , "JUMP_SMS5",
  #"jumpsms6"          , "JUMP_SMS6",
  #"jumpsms7"          , "JUMP_SMS7",
  #"jumpsms8"          , "JUMP_SMS8",
  #"jumpsms9"          , "JUMP_SMS9",
  #"filter"            , "FILTER",
  #"filterclear"       , "FILTER_CLEAR",
  #"filtersms2"        , "FILTER_SMS2",
  #"filtersms3"        , "FILTER_SMS3",
  #"filtersms4"        , "FILTER_SMS4",
  #"filtersms5"        , "FILTER_SMS5",
  #"filtersms6"        , "FILTER_SMS6",
  #"filtersms7"        , "FILTER_SMS7",
  #"filtersms8"        , "FILTER_SMS8",
  #"filtersms9"        , "FILTER_SMS9",
  #"guiprofile"        , "GUIPROFILE_BEGIN",
  #"volampup"          , "VOLAMP_UP",
  #"volampdown"        , "VOLAMP_DOWN",
  #"mplayerosd"        , "SHOW_MPLAYER_OSD", #?
  #"hidesubmenu"       , "OSD_HIDESUBMENU", #depricated
  #"osdleft"           , "OSD_SHOW_LEFT",
  #"osdright"          , "OSD_SHOW_RIGHT",
  #"osdup"             , "OSD_SHOW_UP",
  #"osddown"           , "OSD_SHOW_DOWN",
  #"osdselect"         , "OSD_SHOW_SELECT",
  #"osdvalueplus"      , "OSD_SHOW_VALUE_PLUS",
  #"osdvalueminus"     , "OSD_SHOW_VALUE_MIN",
]


_activate_window = [
  "settings"                 , "Einstellungen",
  "picturessettings"         , "Einstellungen: Bilder",
  "programssettings"         , "Einstellungen: Programme",
  "weathersettings"          , "Einstellungen: Wetter",
  "musicsettings"            , "Einstellungen: Musik",
  "systemsettings"           , "Einstellungen: System",
  "videossettings"           , "Einstellungen: Videos",
  "servicesettings"          , "Einstellungen: Dienste",
  "appearancesettings"       , "Einstellungen: Aussehen",
  "pvrsettings"              , "Einstellungen: PVR",
  "skinsettings"             , "Einstellungen: Skin",
  "addonbrowser"             , "Addon-Browser",
  "addonsettings"            , "Addon- Einstellungen",
  "profilesettings"          , "Profileinstellungen",
  "locksettings"             , "Einstellungen sperren",
  "contentsettings"          , "Inhaltseinstellungen",
  "profiles"                 , "Profile",
  "systeminfo"               , "System-Informationen",
  "testpattern"              , "Testmuster",
  "screencalibration"        , "Bildschirmkalibrierung",
  "loginscreen"              , "Anmeldebildschirm",
  "filebrowser"              , "Dateibrowser",
  "networksetup"             , "Netzwerkeinrichtung",
  "accesspoints"             , "Zugangspunkte",
  "mediasource"              , "Dialog: Medienquelle",
  "startwindow"              , "Startfenster",
  "favourites"               , "Favoriten",
  "contextmenu"              , "Kontextmenü",
  "peripherals"              , "Peripherie-Manager",
  "peripheralsettings"       , "Peripherie-Einstellungen",
  "mediafilter"              , "Medienfilter",
  "visualisationpresetlist"  , "Vis Voreinstellungsliste",
  "filestackingdialog"       , "Dialog: Dateistapelung",
  "smartplaylisteditor"      , "Intelligenter Wiedergabelisten-Editor",
  "smartplaylistrule"        , "Wiedergabelisten-Regel",
  "shutdownmenu"             , "Menü: Herunterfahren",
  "fullscreeninfo"           , "Vollbildschirm-Info",
  "subtitlesearch"           , "Untertitel-Suche",
  "weather"                  , "Wetter",
  "screensaver"              , "Bildschirmschoner",
  "pictureinfo"              , "Bilder-Info",
  "addoninformation"         , "Addon-Info",
  "musicplaylist"            , "Musik-Wiedergabeliste",
  "musicfiles"               , "Musikdateien",
  "musiclibrary"             , "Musik-Bibliothek",
  "musicplaylisteditor"      , "Musik-Wiedergabelisten-Editor",
  "musicinformation"         , "Musik-Info",
  "musicoverlay"             , "Musiküberlagerung",
  "songinformation"          , "Song-Info",
  "karaoke"                  , "Songtext: Karaoke",
  "karaokeselector"          , "Karaoke Song Selector",
  "karaokelargeselector"     , "Karaoke-Songauswahl",
  "movieinformation"         , "Video-Info",
  "videofiles"               , "Videodateien",
  "videooverlay"             , "Videoüberlagerung",
  "videomenu"                , "Video-Menü",
  "videoosd"                 , "Video-OSD",
  "videotimeseek"            , "Video-Zeit-Suche",
  "videobookmarks"           , "Video-Lesezeichen",
  "videoplaylist"            , "Video-Wiedergabeliste",
  "pvrguideinfo"             , "PVR-Betriebsanleitung",
  "pvrrecordinginfo"         , "PVR-Aufnahme-Info",
  "pvrtimersetting"          , "PVR-Timer-Einstellung",
  "pvrgroupmanager"          , "PVR-Gruppenmanager",
  "pvrchannelmanager"        , "PVR-Kanal-Manager",
  "pvrguidesearch"           , "PVR-Anleitung-Suche",
  "pvrchannelscan"           , "PVR-Kanalsuche",
  "pvrupdateprogress"        , "PVR-Aktualisierungsfortschritt",
  "pvrosdchannels"           , "PVR-OSD-Kanäle",
  "pvrosdguide"              , "PVR-OSD-Anleitung",
  "pvrosddirector"           , "PVR-OSD-Direktor",
  "pvrosdcutter"             , "PVR-OSD-Cutter",
  "tvchannels"               , "TV-Kanäle",
  "tvrecordings"             , "TV-Aufnahmen",
  "tvguide"                  , "TV-Programm",
  "tvtimers"                 , "TV-Timer",
  "tvsearch"                 , "TV-Suche",
  "radiochannels"            , "Radiokanäle",
  "radiorecordings"          , "Radioaufnahmen",
  "radioguide"               , "Radio-Programm",
  "radiotimers "             , "Radio-Timer",
  "radiosearch"              , "Radio-Suche",
  "videos,movies"            , "Filme",
  "videos,movietitles"       , "Filmtitel",
  "videos,tvshows "          , "TV-Sendungen",
  "videos,tvshowtitles "     , "TV-Sendungstitel",
  "videos,musicvideos"       , "Musikvideos",
  "videos,recentlyaddedmovies"      , "Kürzlich hinzugefügte Filme",
  "videos,recentlyaddedepisodes"    , "Kürzlich hinzugefügte Episoden",
  "videos,recentlyaddedmusicvideos" , "Kürzlich hinzugefügte Musikvideos"
]

_windows = [
  "global"                   , "Globale Tastenbelegung",
  "fullscreenvideo"          , "Vollbildschirm-Video",
  "fullscreenlivetv"         , "Vollbildschirm-Live-TV",
  "home"                     , "Startbildschirm",
  "programs"                 , "Programme",
  "videos"                   , "Videos",
  "music"                    , "Musik",
  "pictures"                 , "Bilder",
  "pvr"                      , "PVR",
  "filemanager"              , "Dateumanager",
  "pvrosdteletext"           , "OSD-Teletext",
  "virtualkeyboard"          , "Virtuelle Tastatur",
  "playercontrols"           , "Player-Steuerelemente",
  "seekbar"                  , "Suchleiste",
  "musicosd"                 , "Musik-OSD",
  "osdvideosettings"         , "Video-OSD-Einstellungen",
  "osdaudiosettings"         , "Audio-OSD-Einstellungen",
  "visualisation"            , "Visualisierung",
  "slideshow"                , "Diashow"
]

from collections_backport import OrderedDict
from utils import rpc
import xbmc


def action_dict(actions, action_names):
    """Create dict of action->name sorted by name"""
    return OrderedDict(sorted(zip(actions, action_names), key=lambda t: t[1]))


def _get_run_addon_actions():
    addons = []
    addon_types = ['xbmc.python.pluginsource', 'xbmc.python.script']
    for addon_type in addon_types:
        response = rpc('Addons.GetAddons', type=addon_type, properties=['name', 'enabled'])
        res = response['result']
        if 'addons' in res:
            addons.extend([a for a in res['addons'] if a['enabled']])
    actions = ['runaddon(%s)' % a['addonid'] for a in addons]
    names = ['%s starten' % a['name'] for a in addons]
    return action_dict(actions, names)


def _get_activate_window_actions():
    all_windows = _activate_window + _windows[2:] #don't include "global"
    actions = ["activatewindow(%s)" % w_id for w_id in all_windows[0::2]]
    names = ["%s öffnen" % w for w in all_windows[1::2]]
    return action_dict(actions, names)


def _get_action_dict():
    """ Map actions to 'category name'->'action id'->'action name' dict"""
    d = OrderedDict()
    for elem in _actions:
        category = elem[0]
        actions = elem[1][0::2]
        names = elem[1][1::2]
        d[category] = OrderedDict(zip(actions, names))

    d["Fenster"] = _get_activate_window_actions()
    d["Add-ons"] = _get_run_addon_actions()
    return d


ACTIONS = _get_action_dict()
WINDOWS = OrderedDict(zip(_windows[0::2], _windows[1::2]))
